
/**
 * Classe Banco.
 * Classe que gere as vrias operaes possveis sobre
 * contas bancrias, que so instncias da classe 
 * Conta.
 * 
 * ATENO: esta classe est incompleta e serve apenas para demonstrar a capacidade
 * de termos programao genrica - tratar de forma semelhante coisas diferentes, ou seja,
 * enviar a mesma mensagem e receber resultados provenientes de implementaes distintas.
 * 
 * @author F. Mrio Martins
 * @version 1.0 2006
 */

import java.util.*;
public class Banco {

    // Variveis de Instncia
    private TreeMap<String, Conta> contas;
    private String nomeBanco;

    public Banco(String nome) {
        contas = new TreeMap<String, Conta>(); nomeBanco = nome;
    }
    
    public Banco(Banco banco) {
       contas = new TreeMap<String, Conta>();
       for(Conta ct : banco.daContas()) 
          contas.put(ct.getNumConta(), ct.clone());
    }

    public Banco(TreeMap<String, Conta> cts, String nome) {
        nomeBanco = nome;
        contas = new TreeMap<String, Conta>(); 
        for(Conta cb : cts.values())
            contas.put(cb.getNumConta(), cb.clone());
    }
    
    
    /**
     * Mtodo que d o valor total que o Banco tem de entregar aos seus clientes.
     *  o somatrio das sucessivas invocaes de getValor() a cada conta.
     */
    
    public double getTotalDinheiroNecessario() {
        
        double totaldinheiro = 0;
        for(Conta c:this.contas.values())
          totaldinheiro += c.getValor();
         
        return totaldinheiro;  
    }      
    
    
    // Nmero total de contas
    public int numContas() { return contas.size(); }
    
    // Nome actual do Banco
    public String getNomeBanco() { return nomeBanco; }
    
    public void mudaNmBanco(String nvNm) { nomeBanco = nvNm; }

    public Conta daConta(String numConta) {
            return contas.get(numConta).clone(); // devolve cpia
    }  
    
    public Set<Conta> daContas() {
        HashSet<Conta> cts = new HashSet<Conta>();
        for(Conta ct : contas.values()) cts.add(ct.clone());
        return cts;
    }

    public boolean existeConta(String numConta) {
        return contas.containsKey(numConta);
    }

    public void criaConta(Conta conta) { 
        contas.put(conta.getNumConta(), conta.clone());
    }

    public ArrayList<String> listaNumeros() {
        ArrayList<String> nums = new ArrayList<String>();     
        for(String numc : contas.keySet()) 
            nums.add(numc); 
        return nums;
    }

    public Set<String> conjNumeros() {        
        TreeSet<String> cnums = 
             new TreeSet<String>(contas.keySet());     
        return cnums;
    }

    //...
    //Outros mtodos
    //...
    
   public void removeConta(String numConta) {
        contas.remove(numConta);
   }

  private long numDiasAteHoje(GregorianCalendar data) {
      GregorianCalendar hoje = new GregorianCalendar();
      long hojeMils = hoje.getTimeInMillis();
      long dataMils = data.getTimeInMillis();
      long milis = hojeMils - dataMils;
      return milis/(24*60*60*1000);
  }

  //...
  //...
  
  public Banco clone() { return new Banco(this); }
}
